package org.example;

import java.time.*;
import java.time.format.DateTimeFormatter;
import java.time.temporal.TemporalAdjusters;
import java.util.ArrayList;
import java.util.List;
import java.util.TimeZone;

public class Main {
    public static void main(String[] args) {
        // Задание 1
        System.out.println("Задание 1: должность, которую человек занимал на последний день месяца");
        List<LabourRelations> artemMartynovLabourRelations = new ArrayList<>();
        artemMartynovLabourRelations.add(new LabourRelations("Ведущий инженер", LocalDate.of(2023, 4, 30)));
        artemMartynovLabourRelations.add(new LabourRelations("Старший инженер", LocalDate.of(2022, 4, 11)));
        Person artemMartynov = new Person("Мартынов Артём", artemMartynovLabourRelations);
        System.out.println("Мартынов Артём:");
        System.out.println("01.2021: " + artemMartynov.getPosition(1, 2021));
        System.out.println("03.2022: " + artemMartynov.getPosition(3, 2022));
        System.out.println("04.2022: " + artemMartynov.getPosition(4, 2022));
        System.out.println("04.2023: " + artemMartynov.getPosition(4, 2023));

        List<LabourRelations> ivanIvanovLabourRelations = new ArrayList<>();
        Person ivanIvanov = new Person("Иванов Иван", ivanIvanovLabourRelations);
        System.out.println("Иванов Иван: ");
        System.out.println("01.2021: " + ivanIvanov.getPosition(1, 2021));

        // Задание 2
        System.out.println("\nЗадание 2: ближайший год, когда дата является указанным днем недели");
        System.out.println("01.05 - понедельник: " + getNearestYear(LocalDate.of(2023, 5, 1), 1));
        System.out.println("01.05 - вторник: " + getNearestYear(LocalDate.of(2023, 5, 1), 2));
        System.out.println("01.05 - среда: " + getNearestYear(LocalDate.of(2023, 5, 1), 3));
        System.out.println("01.05 - четверг: " + getNearestYear(LocalDate.of(2023, 5, 1), 4));
        System.out.println("01.05 - пятница: " + getNearestYear(LocalDate.of(2023, 5, 1), 5));
        System.out.println("01.05 - суббота: " + getNearestYear(LocalDate.of(2023, 5, 1), 6));
        System.out.println("01.05 - воскресенье: " + getNearestYear(LocalDate.of(2023, 5, 1), 6));
        System.out.println("01.04 - суббота: " + getNearestYear(LocalDate.of(2023, 4, 1), 6));

        // Задание 3
        System.out.println("\nЗадание 3: время доставки");
        System.out.println("00:00 - " + getDeliveryTime(LocalTime.of(0, 0)));
        System.out.println("10:00 - " + getDeliveryTime(LocalTime.of(10, 0)));
        System.out.println("17:30 - " + getDeliveryTime(LocalTime.of(17, 30)));
        System.out.println("23:59 - " + getDeliveryTime(LocalTime.of(23, 59)));

        // Задание 4
        System.out.println("\nЗадание 4: количество секунд до Нового Года");
        System.out.println("Sun Jan 01 2023 00:00:00 GMT+0300 - " + getTimeToNewYear(1672520400L));
        System.out.println("Mon Jan 01 2024 00:00:00 GMT+0300 (високосный год) - " + getTimeToNewYear(1704056400L));
        System.out.println("Wed Jan 01 2025 00:00:00 GMT+0300 - " + getTimeToNewYear(1735678800L));
        System.out.println("Sat Dec 30 2023 10:00:00 GMT+0300 - " + getTimeToNewYear(1703919600L));
        System.out.println("Sun Dec 30 2023 10:00:01 GMT+0300 - " + getTimeToNewYear(1703919601L));
        System.out.println("Sun Dec 31 2023 10:00:00 GMT+0300 - " + getTimeToNewYear(1704006000L));
    }
    public static int getNearestYear(LocalDate date, int dayOfWeek) {
        DayOfWeek dayOfWeekEnum = DayOfWeek.of(dayOfWeek);
        LocalDate now = LocalDate.now();
        date = LocalDate.ofYearDay(now.getYear(), date.getDayOfYear()); // установка текущего года
        if (date.getMonth().equals(now.getMonth()) && (date.getDayOfMonth() >= now.getDayOfMonth())) { // одинаковый месяц и день еще не прошел в этом году
            if (date.getDayOfWeek().equals(dayOfWeekEnum)) {
                return date.getYear();
            }
        } else if (date.getMonth().compareTo(now.getMonth()) > 0) { // месяц еще не наступил в этом году
            if (date.getDayOfWeek().equals(dayOfWeekEnum)) {
                return date.getYear();
            }
        }
        while (true) {
            date = date.plusYears(1); // добавление одного года в цикле, пока не будет найден ближайший год
             if (date.getDayOfWeek().equals(dayOfWeekEnum)) {
                 return date.getYear();
             }
        }
    }
    public static String getDeliveryTime(LocalTime time) {
        if ((time.isAfter(LocalTime.of(0, 0)) && time.isBefore(LocalTime.of(17, 30)))
                || time.equals(LocalTime.of(0, 0))) { // если время в промежутке от 00:00 до 17:30 (00:00 включительно, 17:30 нет)
            return "Время доставки - сегодня";
        }
        else {
            LocalDate today = LocalDate.now(); // дата заказа
            LocalDate tomorrow = today.plusDays(1); // дата следующего дня
            if (tomorrow.getDayOfWeek() == DayOfWeek.SATURDAY ||
                    tomorrow.getDayOfWeek() == DayOfWeek.SUNDAY) { // если выходной
                LocalDate deliveryDate = today.with(TemporalAdjusters.next(DayOfWeek.MONDAY)); // дата следующего понедельника
                return String.format("Время доставки - %s 09:00", deliveryDate.format(DateTimeFormatter.ofPattern("dd.MM.yyyy")));
            }
            else {
                return String.format("Время доставки - %s 09:00", tomorrow.format(DateTimeFormatter.ofPattern("dd.MM.yyyy")));
            }
        }
    }
    public static String getTimeToNewYear(Long startTimestamp) {
        LocalDateTime localDateTime = LocalDateTime.ofInstant(Instant.ofEpochSecond(startTimestamp),
                TimeZone.getDefault().toZoneId());
        if (localDateTime.getMonth() == Month.DECEMBER && localDateTime.getDayOfMonth() == 31) {
            return "Новый год сегодня!";
        }
        else {
            LocalDateTime newYearLocalDateTime = LocalDateTime.of(
                    localDateTime.getYear() + 1, Month.JANUARY, 1, 0, 0); // 1 января следующего года
            Long difference = newYearLocalDateTime.toEpochSecond(OffsetDateTime.now().getOffset()) - startTimestamp;
            return String.format("Секунд до нового года - %s", difference);

        }
    }
}