package org.example;

import java.time.LocalDate;
import java.util.Calendar;
import java.util.Comparator;
import java.util.List;
import lombok.AllArgsConstructor;

@AllArgsConstructor
public class Person {
    private String name;
    private List<LabourRelations> labourRelationsList; // список должностей

    public String getPosition(int month, int year) {
        labourRelationsList.sort(Comparator.comparing(LabourRelations::getStartDate)); // сортировка должностей по датам (от старых к новым)
        Calendar calendar = Calendar.getInstance();
        calendar.set(year,month - 1, 1);
        int lastDay = calendar.getActualMaximum(Calendar.DAY_OF_MONTH); // получение последнего дня месяца
        LocalDate day = LocalDate.of(year, month, lastDay);

        if (this.labourRelationsList.isEmpty() || (day.compareTo(this.labourRelationsList.get(0).getStartDate()) < 0)) {
            return "Безработный"; // случай, когда проверяемая дата раньше всех даты работы или список пустой
        }
        else {
            for (int i = 0; this.labourRelationsList.size() > i + 1; i++) { // проверка попадания даты в промежутки между датами устройства на работу
                if (day.compareTo(this.labourRelationsList.get(i).getStartDate())  >= 0 && // если проверяемая дата была позже или равна записи i
                        (day.compareTo(this.labourRelationsList.get(i + 1).getStartDate()) < 0)) { // если проверяемая дата была раньше записи i + 1
                    return this.labourRelationsList.get(i).getPosition();
                }
            }
            return this.labourRelationsList.get(this.labourRelationsList.size() - 1).getPosition(); // если ранее не вернули, возвращаем текущую работу
        }
    }
}
